//  cptChar.cpp
//-------------------
// Ce programme l'occurence de certains caractères dans un texte
//
// Paramètres sur la ligne de commandes
//  - Parm #1 : nombre de processus à utiliser
//  - Parm #2 : nom du fichier contenant le texte
//  - Parm #3 : nom du fichier de sortie

#include <thread>
#include <sstream>
#include <iostream>
#include <fstream>
#include <vector>
#include <chrono>

using namespace std;
using namespace std::chrono;

//------------------------------
// Contante globale -- ensemble des caractères à traiter
const char alpha[] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
// Variable globale pour emmagasiner le décompte de caractères
int nbCar[63];

//----------------------------------------------------------------------
// La fonction qui sert à effectuer le décompte
//
// Entrée : index - identifiant du fil
//          depart - indice début de la suite de caractères à traiter
//          fin - indice fin de la suite de caratères à traiter
//          texte - texte à traiter
//          ** alpha (globale) - caractères à compter
// Sortie : ** nbCar : variable globale modifiée par chaque fil
//
// Les processus sont démarrés automatiquement lorsque le code arrive à ce niveau
//
// ********************************************************
// Insérer le code de votre processus ici *****************
//*********************************************************
void decompte(int index, int depart, int fin, string texte)
{
 
    
    
    
    
    
    
}
/********************************************************************************
   Programme principale qui initialise et démarre les fils
   
   Entree : (sur la ligne de commandes)
            nbFil - nombre de fils d'exécution
            nom : fichier contenant le texte
            nom_sortie : fichier contenat le résultat
    
********************************************************************************/
int main(int argc, char *argv[])
{
    int nbFil;          // Nombre de fils d'exécution
    int carParFil[62];  // Pour emmagasiner les décompte des caractères
    string nom,         // nom du fichier contanenat le texte
           nom_sortie,  // nom du fichier contenant le résultat
           texte;       // Texte à traiter
    ifstream manuel;    // Pour lire le texte à traiter
    ofstream cpt_res;   // Pour écrire le résultat en sortie
    
    // Obtention des arguments 
    nbFil = stoi(argv[1]);  // cout<< nbFil << " -- ";
    nom = argv[2];          // cout<< nom << " -- " ;
    nom_sortie = argv[3];   // cout<< nom << endl ; 
    //-----------------------------
    // Lecture du texte
    manuel.open(nom);
    if (manuel.is_open())
    {
      ostringstream ss;
      ss << manuel.rdbuf(); 
      texte = ss.str();
      manuel.close();
    }
    else cout << "Impossible d'ouvrir le fichier"; 
    //--------------------------------------------
    // On détermine la taille du texte à traiter par chaque pcs
    // ---------------------------------------------------------
    int taille1 = 62 / nbFil;
    int taille2 = 62 % nbFil;
    carParFil[0]=0;
    // Répartition du «reste» du texte entre les processus
     for (int j = 1 ; j <= nbFil; j++)
    {
        if (taille2 > 0)
        {
            carParFil[j] = carParFil[j-1] + taille1 + 1;
            taille2--;
        }
        else carParFil[j] = carParFil[j-1] + taille1 ;
    }
    //---------------------------------------------------------
    // Positionnement du chronomètre pour évaluer la performance
    auto temps_depart = system_clock::now();
    //-------------------------------------------------
    // Initialisation et démarrage des fils d'exécution
    vector<thread> threads;
    for (int i = 0; i< nbFil; i++)
    {  
         threads.push_back(thread(decompte, i, carParFil[i], carParFil[i+1]-1, texte));
    } 
    //-------------------------------------------------
    // Attente de la fin de tous les fils
    for(auto& thread : threads) {  thread.join(); }
    //-------------------------------------------------
    // Arrêt du chronomètre
    auto temps_arret = system_clock::now();

    // -------------------------------------------------
    // Affichage du temps d'exécution
    auto duree = duration_cast<milliseconds>(temps_arret - temps_depart);
    cout << "Temps execution = " << duree.count()/1000.0 << " secondes" << endl;
    // -------------------------------------------------
    // Sauvegarde du résultat dans fichier de sortie
    cpt_res.open(nom_sortie,ios::binary | ios::out);
    if (cpt_res.is_open())
    {
        cpt_res << "Occurences des lettres"<< endl; 
        for (int i = 0; i< 62; i++)
        {  
            if ((i+1)%12 != 0) cpt_res << "(" << alpha[i] << ":" << nbCar[i]<< "), ";
            else cpt_res << "(" << alpha[i] << ":" << nbCar[i]<< ") " << endl;
            // Affichage à l'écran si désiré...
            //cout << "Nombre de " << alpha[i] << " = " << nbCar[i]<< endl;
        } 
    }  
    return 0;
}
